var feed = {title:"Mere Days", top:"Mere Days", bottom:"UK", url:"http://www.irc-junkie.net/meredays/index.php", titleurl:"http://www.meredays.co.uk"};			
	
var scrollArea, scrollbar;

function load ()
{
	scrollbar = new AppleVerticalScrollbar(document.getElementById("myScrollBar"));
	scrollArea = new AppleScrollArea(document.getElementById("contents"), scrollbar);
	scrollArea.scrollsHorizontally = false;
	scrollArea.singlepressScrollPixels = 15;
	
	scrollArea.focus(); // for key control when first loading in Safari
	
	window.onfocus = function () { scrollArea.focus(); }
	window.onblur = function () { scrollArea.blur(); }
	
	if (!window.widget)
	{
		show ();
	}
}


var last_updated = 0;
var xml_request = null;

function show ()
{
	var now = (new Date).getTime();
	
	if ((now - last_updated) > 900000)
	{
		if (xml_request != null)
		{
			xml_request.abort();
			xml_request = null;
		}
		xml_request = new XMLHttpRequest();

		xml_request.onload = function(e) {xml_loaded(e, xml_request);}
		xml_request.overrideMimeType("text/xml");
		xml_request.open("GET", feed.url);
		xml_request.setRequestHeader("Cache-Control", "no-cache");
		xml_request.send(null);
    }
}

if (window.widget)
{
	widget.onshow = show;
}

function findChild (element, nodeName)
{
	var child;
	
	for (child = element.firstChild; child != null; child = child.nextSibling)
	{
		if (child.nodeName == nodeName)
			return child;
	}
	
	return null;
}

function xml_loaded (e, request) 
{
	xml_request = null;
	if (request.responseXML)
	{		
		var contents = document.getElementById('contents');
		while (contents.hasChildNodes())
		{
			contents.removeChild(contents.firstChild);
		}
		
		var events = findChild(request.responseXML, 'events');
		if (!events) {
			alert("no <events> element"); 
			document.getElementById("ohnoes").style.display = "block";
			return;
		}
		
		document.getElementById("ohnoes").style.display = "none";

		var results = new Array;
		
		for( var item = events.firstChild; item != null; item = item.nextSibling)
		{
			if( item.nodeName == 'event' ) 
			{
				var title = findChild (item, 'title');
			
				if( title != null ) 
				{
					var link = findChild (item, 'link');
					var merelevel = findChild (item, 'merelevel');
					results[results.length] = {title:title.firstChild.data, 
						link:(link != null ? link.firstChild.data : null), 
						merelevel:merelevel.firstChild.data
				   };
				}
			}
		}
		
		nItems = results.length;
		var even = true;		
				
		for (var i = 0; i < nItems; ++i)
		{
			var item = results[i];
			var row = createRow (item.title, item.link, item.merelevel, even);
			even = !even;
			
			contents.appendChild (row);
		}

		scrollArea.refresh();
		
		last_updated = (new Date).getTime();
	}
}

function createRow (title, link, merelevel, even)
{
	var row = document.createElement ('div');
	row.setAttribute ('class', 'row ' + (even ? 'light' : 'dark'));
	
	var title_div = document.createElement ('div');
	title_div.innerText = title;
	title_div.setAttribute ('class', 'title');
	if (link != null)
	{
		title_div.setAttribute ('the_link', link);
		title_div.setAttribute ('onclick', 'clickOnTitle (event, this);');
	}
	row.appendChild (title_div);
	
	if (merelevel != null)
	{
		var mere_div = document.createElement ('div');
		mere_div.setAttribute ('class', 'mere');
		mere_div.innerText = merelevel;
		
		row.appendChild (mere_div);
	}
	
	return row;	
}

function clickOnTitle (event, div)
{
	if (window.widget)
	{
		widget.openURL (div.the_link);
	} else document.location = div.the_link;
}

function clickOnFeedTitle(event)
{
	if (window.widget)
	{
			widget.openURL (feed.titleurl);
	} else document.location = feed.titleurl;
}
